/*************************************************************/
/*  lorenz.c   SS June 94                                    */
/*                                                           */
/*************************************************************/

#include <math.h>
#include <stdio.h>
#include <graphics.h>
#include <conio.h>

double pi=3.14159265358979323846264338;

void main()
{
   int gdriver = DETECT, gmode, errorcode;

   long x72,y72,x7,y7,i,n;

   double v1,v2,c,r,dt,x,y,z,x1,y1,x0,y0,ss;

   clrscr();

   printf("Input delay (1-100000):");
   scanf("%D",&n);

   clrscr();

   initgraph(&gdriver,&gmode, "");

   errorcode = graphresult();


   v1=0.0; v2=90.0;

   v1=cos(v1*pi/180.0);
   v2=cos(v2*pi/180.0);

   c=-6.0;
   r=28.0;
   dt=0.005;
   x0=320;
   y0=400;
   ss=8.0/3.0;

   setcolor(4);

   x=1.0; y=1.0; z=1.0;
   x72=(int)(x0); y72=(int)(y0);

   do {
     x1=x;
     y1=y;

     x=x+10.0*(y-x)*dt;
     y=y+(-x1*z+r*x1-y)*dt;
     z=z+(x1*y1-ss*z)*dt;

     x7=(int)(c*(x+y*v1)+x0+0.5);
     y7=(int)(c*(z+y*v2)+y0+0.5);

     line(x72,y72,x7,y7);

     x72=x7;
     y72=y7;

     for (i=1; i<=n; i++) ;

   } while (! kbhit());



   getch();

   closegraph();

} /* End  */
