/* elpend.c SS Jan 95 */
#include <math.h>
#include <stdio.h>
#include <graphics.h>

double pi=3.141592653589793238;


void main()
{
double r,g,m,dt,w,l0,l,t,vt,vr,k,dl,at,ar,sw,cw;
long   n,x7,y7,x,y,i,x0,y0,flag;

int gdriver=DETECT,gmode;


   clrscr();
   printf("Elastic pendlum\n\n");
   printf("Input spring constant k (10): ");
   scanf("%lf",&k);
   printf("Input angle w (60): ");
   scanf("%lf",&w);
   printf("Visible pendlum (1/0): ");
   scanf("%D",&flag);
   printf("Input delay (1-100000): ");
   scanf("%D",&n);


   initgraph(&gdriver,&gmode, "");

   r=400.0;
   g=9.81;
   m=0.2;
   dt=0.001;
   w=pi/180.0*w;
   l0=0.4;
   l=0.4;
   t=0.0;
   vt=0.0;
   vr=0.0;
   x0=310;
   y0=0;

   setcolor(14);
   line(0,0,2*x0,y0);
   line(2*x0,y0,2*x0,479);
   line(2*x0,479,0,479);
   line(0,479,0,0);


   x7=x0;
   y7=y0;

   do {
      sw=sin(w);
      cw=cos(w);
      w=w+vt*dt/l;
      dl=l-l0;
      at=-g*sw;
      ar=-k*dl/m+g*cw;
      vt=vt+at*dt;
      vr=vr+ar*dt;
      l=l+vr*dt;

      x=(int)(-r*l*sw+0.5)+x0;
      y=(int)(r*l*cw+0.5)+y0;


      if (flag==1) {
	 setcolor(0);
	 line(x7,y7,x0,y0);
	 setcolor(1);
	 line(x,y,x0,y0);
      }

      putpixel(x,y+1,4);

      x7=x;
      y7=y;

      for (i=1; i<=n; i++) ;

   } while (!kbhit());

   getch();

   closegraph();
} /* end */